exports.move_element_by_delta = (element, arr, delta) => {
  const from = arr.map(c => JSON.stringify(c)).indexOf(JSON.stringify(element));
  const to = from + delta;
  if (from < 0 || from >= arr.length || to < 0 || to >= arr.length) {
    return arr
  }
  let new_arr = arr.slice();
  if (to >= new_arr.length) {
    var k = to - new_arr.length + 1;
    while (k--) {
      new_arr.push(undefined);
    }
  }
  new_arr.splice(to, 0, new_arr.splice(from, 1)[0]);
  return new_arr; 
};

exports.move_element_by_delta_relative_id = (element, arr, relative_id, delta) => {
  const from = arr.map(c => JSON.stringify(c)).indexOf(JSON.stringify(element));;
  const offset = arr.reduce((accum, item, i) => item.id === relative_id ? i : accum, 0);
  const to = offset + delta;
  if (from < 0 || from >= arr.length || to < 0 || to >= arr.length) {
    return arr
  }
  let new_arr = arr.slice();
  if (to >= new_arr.length) {
    var k = to - new_arr.length + 1;
    while (k--) {
      new_arr.push(undefined);
    }
  }
  new_arr.splice(to, 0, new_arr.splice(from, 1)[0]);
  return new_arr; 
};

exports.safe_spread = (spread_elements) => {
  if (spread_elements.length === 0) {
    return []
  }
  if (spread_elements.length === 1 && Array.isArray(spread_elements[0])) {
    return spread_elements[0]
  }
  return spread_elements
};

exports.head_matches = (head, array) => {
  return !head.some((head_element, i) => array[i] != head_element)
};